<?php
/*
Plugin Name: Send Plain Text Emails
Description: Adds a button to Woocommerce Orders page, Users page and Mailpoet page to allow you to send plain text emails to people. These plain text emails are far more personal than HTML emails and get better open/click/response rates.
Version: 1.0
*/

function plain_text_email_admin_footer() {
    ?>
    <script type="text/javascript">
        jQuery(document).ready(function() {
			if (jQuery('.email').length > 0 || jQuery('.username').length > 0) {
				jQuery('<input id="sendplaintextemail" type="button" value="Send Plain Text Email">').appendTo('.tablenav .actions:nth-child(2)');
			} 
        });
		var pte_emaillist = [];
		jQuery(document).on('click', '#sendplaintextemail', function() {
			jQuery('<div id="plaintextemailpopover" style="width:80%; position:absolute; left:10%; top:5%; z-index:999999; background:white; padding:25px; border:1px solid #ddd;"><h2>Send a plain text email</h2><p>From Name <br><input type="text" id="pte_from" placeholder="From Name" style="min-width:50%;" value="<?php echo get_option('blogname'); ?>" /></p><p>From Email<br><input style="min-width:50%;" type="text" id="pte_fromemail" placeholder="From Email" value="<?php echo get_option('admin_email'); ?>" /></p><p>Subject<br><input type="text" style="min-width:50%;" id="pte_subject" placeholder="Subject" /></p><p>Intro if name available<br><textarea id="pte_introname">Hi [firstname],\n\n</textarea></p><p>Intro if no name available<br><textarea id="pte_intrononame">Hi,\n\n</textarea></p><p>Message<br><textarea id="pte_message" style="min-width:50%; min-height:120px;"></textarea></p><p><input type="button" id="pte_cancel" value="Cancel">&nbsp; &nbsp; <input type="button" id="pte_send" value="Send"></p><h3>Emails will be sent to the following people</h3><div><ul id="pte_emaillist"></ul></div></div>').appendTo('body');
			jQuery('#the-list input[type=checkbox]:checked').each(function() {
//				console.log(jQuery('.email a', jQuery(this).parent().parent()).attr('href').replace('mailto:', ''));
				var pte_emailperson = {};
				pte_emailperson.emailaddress = jQuery('.email a', jQuery(this).parent().parent()).attr('href').replace('mailto:', '');
				pte_emailperson.fullname = '';
				pte_emailperson.firstname = '';				
				if (jQuery('.shipping_address', jQuery(this).parent().parent()).length > 0) {
					pte_emailperson.fullname = jQuery('.shipping_address a', jQuery(this).parent().parent()).text().split(',')[0];
					console.log ('**' + pte_emailperson.fullname);
				} else {
					if (jQuery('td.name', jQuery(this).parent().parent()).length > 0) {
						pte_emailperson.fullname =  jQuery('td.name', jQuery(this).parent().parent()).text();
						console.log ('__' + pte_emailperson.fullname);
					} 
				}
				try {
					var pte_nametokens = pte_emailperson.fullname.split(' ');
					pte_emailperson.firstname = pte_nametokens[0];
				} catch(e) {
				}
				pte_emaillist.push(pte_emailperson);
			});
			jQuery('#wysija-user input[type=checkbox]:checked').each(function() {
				var pte_emailperson = {};
				pte_emailperson.fullname = '';
				pte_emailperson.firstname = '';				
				var pte_node = jQuery('.username strong', jQuery(this).parent().parent()).clone();
				jQuery(pte_node).find('script').remove();
				pte_emailperson.emailaddress = jQuery(pte_node).text();
				pte_emailperson.fullname = jQuery('.username p', jQuery(this).parent().parent()).text();
				try {
					var pte_nametokens = pte_emailperson.fullname.split(' ');
					pte_emailperson.firstname = pte_nametokens[0];
				} catch(e) {
				}
				pte_emaillist.push(pte_emailperson);
			});
			for (var i=0; i< pte_emaillist.length; i++) {
				jQuery('#pte_emaillist').append('<li>' + pte_emaillist[i].firstname + ' &lt;' + pte_emaillist[i].emailaddress + '&gt; (' + pte_emaillist[i].fullname + ')');
			}
		});
		jQuery(document).on('click', '#pte_send', function() {
			jQuery('#pte_send').val('Sending...');
			jQuery('#pte_send').prop('disabled','true');
			var data = {
				'action': 'send_plain_text_email',
				'mailinglist': pte_emaillist,
				'from': jQuery('#pte_from').val(),
				'fromemail': jQuery('#pre_fromemail').val(),
				'subject': jQuery('#pte_subject').val(),
				'introname': jQuery('#pte_introname').val(),
				'intrononame': jQuery('#pte_intrononame').val(),
				'message': jQuery('#pte_message').val()				
			};
			// We can also pass the url value separately from ajaxurl for front end AJAX implementations
			jQuery.post('<?php echo admin_url('admin-ajax.php'); ?>', data, function(response) {
				alert('Sent: ' + response);
				jQuery('#plaintextemailpopover').remove();
				pte_emaillist = [];
			});
		});
		jQuery(document).on('click', '#pte_cancel', function() {
			jQuery('#plaintextemailpopover').remove();
			pte_emaillist = [];
		});
    </script>
    <?php
}
add_action('admin_footer', 'plain_text_email_admin_footer');

add_action( 'wp_ajax_send_plain_text_email', 'send_plain_text_email' );
function send_plain_text_email() {
	if (!is_admin()) {
		die ('Only admins can send plain text emails');
	}
	$headers = 'From: ' . $_POST['from'] . ' <' . $_POST['fromemail'] . '>' . "\r\n";
	$mailinglist = $_POST['mailinglist'];
	
	$i = 0; $f = 0;
	$m = "";
	foreach ($mailinglist as $target) {
		$intromessage = $_POST['intrononame'];
		if (strlen($target['firstname']) > 0) {
			$intromessage = str_replace('[firstname]', stripslashes($target['firstname']), $_POST['introname']);
		}
		$message = $intromessage . stripslashes($_POST['message']);
		if (wp_mail($target['emailaddress'], stripslashes($_POST['subject']), $message, $headers)) {
			$i++;
		} else {
			$f++;
		}
	}
	
	die("$i emails sent successfully, $f failed\n"); 
}